# Terraform Module AWS Backup

Module to manage AWS Backup with Terraform.

Handles a (logically air-gapped) Vault, linked Vault KMS key, lock configurations and Vault resource-based policy + identity-based IAM Policies.
As well as: global & region settings, (restore testing) Backup Plans, Backup Selections and Backup Framework.
This modules also manage Vault replica in another region with backup copies.

## Limitations

- This module does not offer SNS Topic creation for notifications. One can only input an externally-created SNS topic.
- <https://github.com/hashicorp/terraform-provider-aws/issues/23976>

<!-- BEGIN_TF_DOCS -->
## Requirements

| Name | Version |
|------|---------|
| terraform | >= 1.9 |
| aws | >= 3.30 |

## Providers

| Name | Version |
|------|---------|
| aws | >= 3.30 |
| aws.replica | >= 3.30 |

## Modules

| Name | Source | Version |
|------|--------|---------|
| iam\_policy | gitlab.com/wild-beavers/module-aws-iam-policy/aws | ~> 1.0 |
| kms | gitlab.com/wild-beavers/module-aws-kms/aws | ~> 2.0 |

## Resources

| Name | Type |
|------|------|
| [aws_backup_global_settings.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_global_settings) | resource |
| [aws_backup_logically_air_gapped_vault.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_logically_air_gapped_vault) | resource |
| [aws_backup_plan.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_plan) | resource |
| [aws_backup_region_settings.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_region_settings) | resource |
| [aws_backup_restore_testing_plan.replica](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_restore_testing_plan) | resource |
| [aws_backup_restore_testing_plan.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_restore_testing_plan) | resource |
| [aws_backup_restore_testing_selection.replica](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_restore_testing_selection) | resource |
| [aws_backup_restore_testing_selection.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_restore_testing_selection) | resource |
| [aws_backup_selection.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_selection) | resource |
| [aws_backup_vault.replica](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_vault) | resource |
| [aws_backup_vault.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_vault) | resource |
| [aws_backup_vault_lock_configuration.replica](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_vault_lock_configuration) | resource |
| [aws_backup_vault_lock_configuration.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_vault_lock_configuration) | resource |
| [aws_backup_vault_notifications.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_vault_notifications) | resource |
| [aws_backup_vault_policy.replica](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_vault_policy) | resource |
| [aws_backup_vault_policy.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/backup_vault_policy) | resource |
| [aws_iam_policy.selection_additional_iam_policy](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/iam_policy) | resource |
| [aws_iam_role.backup_selection](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/iam_role) | resource |
| [aws_iam_role.restore_selection](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/iam_role) | resource |
| [aws_iam_role_policy_attachment.backup_selection](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/iam_role_policy_attachment) | resource |
| [aws_iam_role_policy_attachment.backup_selection_additional](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/iam_role_policy_attachment) | resource |
| [aws_iam_role_policy_attachment.restore_selection](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/iam_role_policy_attachment) | resource |
| [aws_iam_role_policy_attachment.restore_selection_additional](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/iam_role_policy_attachment) | resource |
| [aws_caller_identity.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/data-sources/caller_identity) | data source |
| [aws_iam_policy_document.identity_kms](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/data-sources/iam_policy_document) | data source |
| [aws_iam_policy_document.selection_additional_iam_policy](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/data-sources/iam_policy_document) | data source |
| [aws_iam_policy_document.selection_assume_role](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/data-sources/iam_policy_document) | data source |
| [aws_partition.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/data-sources/partition) | data source |
| [aws_region.current](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/data-sources/region) | data source |
| [aws_region.replica](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/data-sources/region) | data source |

## Inputs

| Name | Description | Type | Default | Required |
|------|-------------|------|---------|:--------:|
| current\_account\_id | The account where this module is run. | `string` | `""` | no |
| current\_partition | The current partition of the account. | `string` | `""` | no |
| current\_region | The region where this module is run. | `string` | `""` | no |
| global\_settings\_cross\_account\_enabled | Whether or not to allow cross account backups. This only works from the root account. | `bool` | `false` | no |
| plans | One or more Backup Plans.<br/>Keys are free values.<br/>   - name                    (required(string)):          Name of the Backup Plan to create.<br/>   - tags                    (optional(map(string), {})): Tags to assign specifically to the Backup Plan. Will be merged with `var.tags`.<br/>   - windows\_vss             (optional(bool, false)):     Enable Windows VSS backup option and create a VSS Windows backup.<br/>   - rules                   (optional(map(object))):     Specifies a scheduled task that is used to back up a selection of resources. Keys are free values<br/>      - name                         (required(string)): Display name for a backup rule.<br/>      - schedule                     (optional(string)): CRON expression specifying when AWS Backup initiates a backup job.<br/>      - schedule\_expression\_timezone (optional(string)): Timezone in which the schedule expression is set. Default value: `"Etc/UTC"`.<br/>      - enable\_continuous\_backup     (optional(bool)):   Enable continuous backups for supported resources.<br/>      - start\_window                 (optional(number)): Amount of time in minutes before beginning a backup.<br/>      - completion\_window            (optional(number)): Amount of time in minutes AWS Backup attempts a backup before canceling the job and returning an error.<br/>      - lifecycle                    (optional(object)): Lifecycle defines when a protected resource is transitioned to cold storage and when it expires.<br/>         - cold\_storage\_after                        (optional(number)): Specifies the number of days after creation that a recovery point is moved to cold storage.<br/>         - delete\_after                              (optional(number)): Specifies the number of days after creation that a recovery point is deleted. Must be `90` days greater than `cold_storage_after`.<br/>         - opt\_in\_to\_archive\_for\_supported\_resources (optional(bool)):   Setting will instruct your backup plan to transition supported resources to archive (cold) storage tier in accordance with your lifecycle settings.<br/>      - recovery\_point\_tags          (optional(map(string))): Metadata that you can assign to help organize the resources that you create. Will be merged with `var.tags`.<br/>      - copy\_action                  (optional(string)):      Configuration block(s) with copy operation settings. When `var.replica` is `true` another `copy_action` to the replica vault will be created, regardless of this option.<br/>        - destination\_vault\_arn (optional(string)): Amazon Resource Name (ARN) that uniquely identifies the destination backup vault for the copied backup.<br/>        - lifecycle             (optional(object)): Lifecycle defines when a protected resource is transitioned to cold storage and when it expires.<br/>           - cold\_storage\_after                        (optional(number)): Specifies the number of days after creation that a recovery point is moved to cold storage.<br/>           - delete\_after                              (optional(number)): Specifies the number of days after creation that a recovery point is deleted. Must be `90` days greater than `cold_storage_after`.<br/>           - opt\_in\_to\_archive\_for\_supported\_resources (optional(bool)):   Setting will instruct your backup plan to transition supported resources to archive (cold) storage tier in accordance with your lifecycle settings. | <pre>map(object({<br/>    name        = optional(string, "")<br/>    tags        = optional(map(string), {})<br/>    windows_vss = optional(bool, false)<br/>    rules = optional(map(object({<br/>      name                         = string<br/>      schedule                     = optional(string)<br/>      schedule_expression_timezone = optional(string)<br/>      enable_continuous_backup     = optional(bool)<br/>      start_window                 = optional(number)<br/>      completion_window            = optional(number)<br/>      lifecycle = optional(object({<br/>        cold_storage_after                        = optional(number)<br/>        delete_after                              = optional(number)<br/>        opt_in_to_archive_for_supported_resources = optional(bool)<br/>      }))<br/>      recovery_point_tags = optional(map(string), {})<br/>      copy_action = optional(object({<br/>        destination_vault_arn = string<br/>        lifecycle = optional(object({<br/>          cold_storage_after                        = optional(number)<br/>          delete_after                              = optional(number)<br/>          opt_in_to_archive_for_supported_resources = optional(bool)<br/>        }))<br/>      }))<br/>    })), {})<br/>  }))</pre> | `{}` | no |
| region\_settings | Manage region-level settings for AWS Backup.<br/>  - resource\_type\_opt\_in\_preference     (required, map(string)): Service names along with the opt-in preferences for the Region.<br/>  - resource\_type\_management\_preference (optional, map(string)): Service names along with the management preferences for the Region. For more information, see the [AWS Documentation](https://docs.aws.amazon.com/aws-backup/latest/devguide/API_UpdateRegionSettings.html#API_UpdateRegionSettings_RequestSyntax). | <pre>object({<br/>    resource_type_opt_in_preference     = map(string)<br/>    resource_type_management_preference = optional(map(string), null)<br/>  })</pre> | `null` | no |
| replica\_enabled | Whether to enable replica in another region for the Backup Vault. | `bool` | `false` | no |
| replica\_region | The region where this module must replicate resources. | `string` | `""` | no |
| restore\_selection\_iam\_role | Role to be used for all `var.selections` missing a `iam_role_arn`.<br/>   - name                  required(string):           Name of the IAM Role.<br/>   - description           optional(string, ""):       Description of the IAM Role.<br/>   - path                  optional(string, "/"):      Path of the IAM Role.<br/>   - tags                  optional(map(string), {}):  Tags to assign to the role. Will be merge with `var.tags`.<br/>   - policy\_arns           optional(map(string)):      Policies granting the role access to backup and restore. Defaults to IAM service-roles policies provided by AWS. Keys are free values. | <pre>object({<br/>    name        = optional(string, "")<br/>    description = optional(string, "")<br/>    path        = optional(string, "/")<br/>    tags        = optional(map(string), {})<br/>    policy_arns = optional(map(string), { 0 = "arn:aws:iam::aws:policy/service-role/AWSBackupServiceRolePolicyForRestores" })<br/>  })</pre> | `null` | no |
| restore\_testing\_plans | One or more restore testing Backup Plans.<br/>Keys are free values.<br/>   - name                         (required(string)): Name of the restore testing Plan.<br/>   - schedule\_expression          (required(string)): Schedule expression for the restore testing Plan.<br/>   - schedule\_expression\_timezone (optional(string)): Timezone for the schedule expression. If not provided, the state value will be used.<br/>   - start\_window\_hours           (optional(number)): Number of hours in the start window for the restore testing plan.<br/>   - recovery\_point\_selection     (required(object):  Specifies the recovery point selection configuration.<br/>      - algorithm             (required(string)):       Algorithm used for selecting recovery points. Valid values are "RANDOM\_WITHIN\_WINDOW" and "LATEST\_WITHIN\_WINDOW".<br/>      - recovery\_point\_types  (required(list(string))): Types of recovery points to include in the selection. Valid values are "CONTINUOUS" and "SNAPSHOT".<br/>      - selection\_window\_days (optional(number)):       Number of days within which the recovery points should be selected. Must be a value between 1 and 365. | <pre>map(object({<br/>    name                         = optional(string, "")<br/>    schedule_expression          = optional(string, "")<br/>    schedule_expression_timezone = optional(string)<br/>    start_window_hours           = optional(number)<br/>    recovery_point_selection = optional(object({<br/>      algorithm             = optional(string)<br/>      recovery_point_types  = optional(list(string))<br/>      selection_window_days = optional(number)<br/>    }), {})<br/>  }))</pre> | `{}` | no |
| restore\_testing\_selections | One or more Backup Selections for restore testing.<br/>Keys are free values.<br/>   - name                          (required(string)):       Display name of a resource selection document for restore testing.<br/>   - testing\_plan\_reference        (required(string)):       Key of `var.restore_testing_plans`, to associate this restore testing Backup Selection to.<br/>   - iam\_role\_arn                  (optional(string, "")):   ARN of the IAM role that AWS Backup uses to authenticate when restoring the target resources. If omitted, this module will create a single IAM Role for all restore testing Backup Selections without `iam_role_arn`.<br/>   - protected\_resource\_conditions (optional(list(object))): Tag-based conditions used to specify a set of resources to assign to a restore testing Backup Plan.<br/>      - string\_equals      (optional(list(object))): List of conditions for resource tags. Filters the values of your tagged resources for only those resources that you tagged with the same value. Also called "exact matching."<br/>        - key   (optional(string), ""): Tag name, must start with one of the following prefixes: `[aws:ResourceTag/]`.<br/>        - value (optional(string), ""): Value of the Tag. Maximum length of 256.<br/>      - string\_not\_equals  (optional(list(object))): List of conditions for resource tags. Filters the values of your tagged resources for only those resources that you tagged that do not have the same value. Also called "negated matching."<br/>        - key   (optional(string), ""): Tag name, must start with one of the following prefixes: `[aws:ResourceTag/]`.<br/>        - value (optional(string), ""): Value of the Tag. Maximum length of 256.<br/>   - protected\_resource\_type       (optional(string), ""):       Type of the protected resource.<br/>   - protected\_resource\_arns       (optional(list(string)), []): ARNs for the protected resources.<br/>   - restore\_metadata\_overrides    (optional(map(string)):       Override certain restore metadata keys. | <pre>map(object({<br/>    name                   = optional(string, "")<br/>    testing_plan_reference = optional(string, "")<br/>    iam_role_arn           = optional(string, "")<br/>    protected_resource_conditions = optional(list(object({<br/>      string_equals = optional(list(object({<br/>        key   = string<br/>        value = string<br/>      })))<br/>      string_not_equals = optional(list(object({<br/>        key   = string<br/>        value = string<br/>      })))<br/>    })), [])<br/>    protected_resource_type    = optional(string, "")<br/>    protected_resource_arns    = optional(list(string), [])<br/>    restore_metadata_overrides = optional(map(string), {})<br/>  }))</pre> | `{}` | no |
| selection\_additional\_iam\_policy | IAM Policy to attach to the `var.selection_iam_role` and `var.restore_selection_iam_role`, in additions to these variables own `policy_arns`.<br/>The policy is intended to restrict access to specific resources.<br/><br/>   - name                  required(string):           Name of the IAM Role.<br/>   - description           optional(string, ""):       Description of the IAM Role.<br/>   - path                  optional(string, "/"):      Path of the IAM Role.<br/>   - tags                  optional(map(string), {}):  Tags to assign to the role. Will be merge with `var.tags`.<br/>   - json\_policy           optional(string)):          JSON Policy to attach to the additional IAM Policy.<br/>   - restricted\_tags       optional(map(string)):      Add statements to the policy for every tag:value given. When resources are tagged, grants the policy access to the given combinations only.<br/>   - grant\_kms\_access      optional(bool, true):       Add a statement to grant the policy access to the vault KMS key ID (along with the replica vault KMS key ID, should it be enabled). | <pre>object({<br/>    name             = optional(string, "")<br/>    description      = optional(string, "")<br/>    path             = optional(string, "/")<br/>    tags             = optional(map(string), {})<br/>    json_policy      = optional(string, "")<br/>    restricted_tags  = optional(map(string), {})<br/>    grant_kms_access = optional(bool, true)<br/>  })</pre> | `null` | no |
| selection\_iam\_role | Role to be used for all `var.selections` missing a `iam_role_arn`.<br/>   - name                  required(string):           Name of the IAM Role.<br/>   - description           optional(string, ""):       Description of the IAM Role.<br/>   - path                  optional(string, "/"):      Path of the IAM Role.<br/>   - tags                  optional(map(string), {}):  Tags to assign to the role. Will be merge with `var.tags`.<br/>   - policy\_arns           optional(map(string)):      Policies granting the role access to backup and restore. Defaults to IAM service-roles policies provided by AWS. Keys are free values. | <pre>object({<br/>    name        = optional(string, "")<br/>    description = optional(string, "")<br/>    path        = optional(string, "/")<br/>    tags        = optional(map(string), {})<br/>    policy_arns = optional(map(string), { 0 = "arn:aws:iam::aws:policy/service-role/AWSBackupServiceRolePolicyForBackup" })<br/>  })</pre> | `null` | no |
| selections | One or more Backup Selections.<br/>Keys are free values.<br/>   - name           (required(string)):       Display name of a resource selection document.<br/>   - plan\_reference (required(string)):       Key of `var.plans`, to associate this Backup Selection to.<br/>   - iam\_role\_arn   (optional(string, "")):   ARN of the IAM role that AWS Backup uses to authenticate when restoring and backing up the target resource. If omitted, this module will create a single IAM Role for all Backup Selections without `iam_role_arn`.<br/>   - selection\_tags (optional(list(object))): Tag-based conditions used to specify a set of resources to assign to a Backup Plan.<br/>   - resources      (optional(list(string))): Strings that either contain ARNs or match patterns of resources to assign to a Backup Plan.<br/>   - not\_resources  (optional(list(sting))):  Strings that either contain ARNs or match patterns of resources to exclude to a Backup Plan. | <pre>map(object({<br/>    name           = optional(string, "")<br/>    plan_reference = optional(string, "")<br/>    iam_role_arn   = optional(string, "")<br/>    selection_tags = optional(list(object({<br/>      type  = string<br/>      key   = string<br/>      value = string<br/>    })))<br/>    resources     = optional(list(string), [])<br/>    not_resources = optional(list(string), [])<br/>  }))</pre> | `{}` | no |
| tags | Tags to be shared among all resources of this module. | `map(string)` | `{}` | no |
| testing\_prefix | Prefix to be used for all resources names. Specifically useful for tests. A 4-characters alphanumeric string. It must start by a lowercase letter. | `string` | `""` | no |
| vault | logically\_air\_gapped (optional(bool, false)): Whether to make a logically air-gapped Backup Vault<br/><br/>name                (required(map(string))):     Name of the Backup Vault to create. Must contain the "name" key.<br/>force\_destroy       (optional(bool, false)):     Indicates that all recovery points stored in the Vault are deleted so that the Vault can be destroyed without error.<br/>kms\_key\_arn         (optional(string, "")):      ARN of the server-side encryption key that is used to protect your backups. Conflicts with `var.vault_kms_key`.<br/>kms\_key\_replica\_arn (optional(string, "")):      ARN of the replica of the the server-side encryption key that is used to protect your backups. Conflicts with `var.vault_kms_key`. Ignored if `var.replica_enabled` is `false`.<br/>tags                (optional(map(string), {})): Tags to assign specifically to the Backup Vault. Will be merged with `var.tags`.<br/><br/>lock\_changeable\_for\_days (optional(number)): Number of days before the lock date, a grace period. If omitted creates a vault lock in `governance` mode - no real lock, otherwise it will create a vault lock in `compliance` mode, locked from any kind of deletion.<br/>lock\_max\_retention\_days  (optional(number)): Maximum retention period that the Vault retains its recovery points.<br/>lock\_min\_retention\_days  (optional(number)): Minimum retention period that the vault retains its recovery points.<br/><br/>sns\_topic\_arn       (optional(string, "")):       ARN that specifies the topic for a Backup Vault’s events<br/>backup\_vault\_events (optional(list(string), [])): Events that indicate the status of jobs to back up resources to the backup vault.<br/><br/>policy (optional(string, ""): Backup vault access policy document in JSON format. Should `var.vault_iam_policy_xxx` be also provided, this would be used as an additional policy merged with the generated resource-based policy. | <pre>object({<br/>    logically_air_gapped = optional(bool, false)<br/><br/>    name                = optional(string, "")<br/>    force_destroy       = optional(bool, false)<br/>    kms_key_arn         = optional(string, "")<br/>    kms_key_replica_arn = optional(string, "")<br/>    tags                = optional(map(string), {})<br/><br/>    lock_changeable_for_days = optional(number)<br/>    lock_max_retention_days  = optional(number)<br/>    lock_min_retention_days  = optional(number)<br/><br/>    sns_topic_arn       = optional(string, "")<br/>    backup_vault_events = optional(list(string), [])<br/><br/>    policy = optional(string, "")<br/>  })</pre> | `null` | no |
| vault\_iam\_policy\_entity\_arns | Restrict access to the key to the given IAM entities (roles or users) for the resource-based policy. Wildcards are allowed. Allowed keys are `ro`, `rw`, `rwd`, `delete`, `audit` or `full`, each specifying the expected level of access for entities inside. | `map(map(string))` | `{}` | no |
| vault\_iam\_policy\_export\_actions | Whether or not to export IAM policies actions. A lightweight way to generate your own policies. | `bool` | `false` | no |
| vault\_iam\_policy\_identity | Identity-based IAM Policies to create.<br/>Only policies fitting resource-based user-provided scopes (`ro`, `rw`, `rwd`, `delete`, `audit` and `full`) will be created.<br/>   - name\_template           (required, string):           Name template of the IAM Policies. Expect a `%s` to be replace with the user-provided scope (`ro`, `rw`, `rwd`, `delete`, `audit` and `full`).<br/>   - description\_template    (required, string):           Description template of the IAM Policies. Expect a `%s` to be replace with the user-provided scope (`ro`, `rw`, `rwd`, `delete`,  `audit` and `full`).<br/>   - path                    (optional, string, "/"):      Path of the IAM Policies.<br/>   - tags                    (optional, map(string), {}):  Tags of the IAM Policies. Will be merged with `var.tags`. | <pre>object({<br/>    name_template        = string<br/>    description_template = string<br/>    path                 = optional(string, "/")<br/>    tags                 = optional(map(string), {})<br/>  })</pre> | `null` | no |
| vault\_iam\_policy\_identity\_document | Arguments specific for the identity-based Policy documents.<br/>Mandatory if `var.iam_policy_identity`, but might be used solely in combination with `var.iam_policy_identity_export_jsons`.<br/>   - source\_policy\_documents (optional, list(string), []): List of JSON strings to be concatenated to the identity-based polices.<br/>   - resources\_arns          (optional(list(string), []):  ARNs of resources created outside this module to compose the IAM identity-based Policies with. | <pre>object({<br/>    source_policy_documents = optional(list(string), [])<br/>    resources_arns          = optional(list(string), [])<br/>  })</pre> | `{}` | no |
| vault\_iam\_policy\_identity\_export\_jsons | Whether to export identity-based IAM policies contents as JSON. Setting this to `true` do not create any policies. This can be used instead of or in combination with `var.external_iam_policy`. | `bool` | `false` | no |
| vault\_iam\_policy\_restrict\_by\_account\_ids | Restrict IAM Policy by the given account IDs. Resource-based Policy will whitelist given list. If empty, no restriction will be applied. Especially useful when IAM entities contains accounts wildcards. | `list(string)` | `[]` | no |
| vault\_iam\_policy\_restrict\_by\_regions | Restrict resource-based IAM Policy by the given regions. Resource-Based Policy will whitelist given list. If empty, no restriction will be applied. Especially useful when IAM entities contains region wildcards. | `list(string)` | `[]` | no |
| vault\_iam\_policy\_sid\_prefix | Use a prefix for all `Sid` of all the policies created by this module. | `string` | `""` | no |
| vault\_iam\_policy\_source\_arns | Restrict accesses to the given source ARNs for the resource-based policy. Wildcards are allowed. Keys are scope: `ro`, `rw`, `rwd`, `delete`, `audit` or `full`, each specifying the expected level of access for entities defined within. | `map(map(string))` | `{}` | no |
| vault\_kms\_key | Options of the KMS Key to create.<br/>  - alias                   (required, string):      KMS key alias; Display name of the KMS key. Omit the `alias/`.<br/>  - policy\_json             (optional, string):      Additional policy to attach to the KMS key, merged with the resource-based policy.<br/>  - description             (optional, string, ""):  Description of the key.<br/>  - rotation\_enabled        (optional, bool, true):  Whether to automatically rotate the KMS key linked to the secrets.<br/>  - deletion\_window\_in\_days (optional, number, 7):   The waiting period, specified in number of days. After the waiting period ends, AWS KMS deletes the KMS key. If you specify a value, it must be between `7` and `30`, inclusive. If you do not specify a value, it defaults to `7`.<br/>  - tags                    (optional, map(string)): Tags to be used by the KMS key of this module. | <pre>object({<br/>    alias                   = optional(string, null)<br/>    policy_json             = optional(string, null)<br/>    description             = optional(string, "")<br/>    rotation_enabled        = optional(bool, true)<br/>    deletion_window_in_days = optional(number, 7)<br/>    tags                    = optional(map(string), {})<br/>  })</pre> | `null` | no |

## Outputs

| Name | Description |
|------|-------------|
| aws\_backup\_plans | n/a |
| aws\_backup\_restore\_testing\_plan | n/a |
| aws\_backup\_vault | n/a |
| aws\_iam\_policies | n/a |
| aws\_kms\_alias | n/a |
| aws\_kms\_key | n/a |
| backup\_selection\_aws\_iam\_role | n/a |
| precomputed | n/a |
| replica\_aws\_backup\_restore\_testing\_plan | n/a |
| replica\_aws\_backup\_vault | n/a |
| replica\_aws\_kms\_alias | n/a |
| replica\_aws\_kms\_key | n/a |
| restore\_selection\_aws\_iam\_role | n/a |
| selection\_additional\_aws\_iam\_policy | n/a |
<!-- END_TF_DOCS -->
